org.jfree.report.modules.preferences.base

## Interface ConfigStorage

- All Known Implementing Classes:
    FileConfigStorage, NullConfigStorage

      public interface ConfigStorage

  Config storage implementations are used to store a set of properties to a certain key.

  A valid configuration path does not contain dots, semicolons or colons.

  A valid path obeys to the same rules as java identifiers ..
  Author:
    Thomas Morgner

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `isAvailable(java.lang.String configPath)` Tests, whether some configuration data exists for the given configuration.
    `org.pentaho.reporting.libraries.base.config.Configuration` | `load(java.lang.String configPath, org.pentaho.reporting.libraries.base.config.Configuration defaults)` Loads the properties from the given path, specifying the given properties as default.
    `void` | `store(java.lang.String configPath, org.pentaho.reporting.libraries.base.config.Configuration properties)` Stores the given properties on the defined path.

- - ### Method Detail

    - #### store

          void store(java.lang.String configPath,
                     org.pentaho.reporting.libraries.base.config.Configuration properties)
              throws ConfigStoreException

      Stores the given properties on the defined path.
      Parameters:
        `configPath` - the path on where to store the properties.
        `properties` - the properties which should be stored.
      Throws:
        `ConfigStoreException` - if an error occured.

    - #### load

          org.pentaho.reporting.libraries.base.config.Configuration load(java.lang.String configPath,
                                                                         org.pentaho.reporting.libraries.base.config.Configuration defaults)
                                                                  throws ConfigStoreException

      Loads the properties from the given path, specifying the given properties as default.
      Parameters:
        `configPath` - the configuration path from where to read the properties.
        `defaults` - the property set that acts as fallback to provide default values.
      Returns:
        the loaded properties
      Throws:
        `ConfigStoreException` - if an error occured.

    - #### isAvailable

          boolean isAvailable(java.lang.String configPath)

      Tests, whether some configuration data exists for the given configuration.
      Parameters:
        `configPath` - the configuration path to the property storage.
      Returns:
        true, if there are properties under this path, false otherwise.